"{ Package: 'stx:goodies/monticello' }"

Object subclass:#MCReader
	instanceVariableNames:'stream'
	classVariableNames:''
	poolDictionaries:''
	category:'Monticello-Storing'
!


!MCReader class methodsFor:'instance creation'!

on: aStream
	^ self new stream: aStream
!

on: aStream name: aFileName
	| class |
	class := self readerClassForFileNamed: aFileName.
	^ class
		ifNil: [self error: 'Unsupported format: ', aFileName]
		ifNotNil: [class on: aStream]
! !

!MCReader class methodsFor:'testing'!

canReadFileNamed: fileName
	^ (fileName endsWith: self extension)
!

concreteSubclasses
	^ self allSubclasses reject: [:c | c isAbstract]
!

isAbstract
	^ (self respondsTo: #extension) not
!

readerClassForFileNamed: fileName
	^ self concreteSubclasses
		detect: [:c | c canReadFileNamed: fileName]
		ifNone: [nil]
! !

!MCReader methodsFor:'accessing'!

stream: aStream
	stream := aStream
! !

!MCReader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCReader.st,v 1.2 2011-08-20 11:46:00 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCReader.st,v 1.2 2011-08-20 11:46:00 cg Exp $'
!

version_SVN
    ^ 'Id: MCReader.st 5 2010-08-29 07:30:29Z vranyj1 '
! !
